package ij3d.geom;

/**
Copyright (C) Thomas Boudier

License:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *

/**
 * Class Sphere3D
 * Simple class to define a sphere in 3D space
 *
 * @author     thomas
 * @created    9 janvier 2009
 */
public class Sphere3D extends Point3D {

	//
	// Fields
	//

	private double radius = 0;

	//
	// Constructors
	//
	/**
	 *Constructor for the Sphere3D object
	 */
	public Sphere3D() {
		super();
	}


	/**
	 *Constructor for the Sphere3D object
	 *
	 * @param  a  Description of the Parameter
	 * @param  b  Description of the Parameter
	 * @param  c  Description of the Parameter
	 */
	public Sphere3D(double a, double b, double c) {
		super(a, b, c);
	}


	/**
	 *Constructor for the Sphere3D object
	 *
	 * @param  v  Description of the Parameter
	 */
	public Sphere3D(Vector3D v) {
		super(v.getX(), v.getY(), v.getZ());
	}

	//
	// Methods
	//


	//
	// Accessor methods
	//

	/**
	 * Set the value of radius
	 *
	 * @param  newVar  the new value of radius
	 */
	private void setRadius(double newVar) {
		radius = newVar;
	}


	/**
	 * Get the value of radius
	 *
	 * @return    the value of radius
	 */
	public double getRadius() {
		return radius;
	}

	//
	// Other methods
	//

}

