package ij3d.geom;

/**
Copyright (C) Thomas Boudier

License:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *

/**
 *  Description of the Class
 *
 *@author     cedric
 *@created    12 novembre 2003
 */
public class Voxel3D extends Point3D {

    /**
     *  Description of the Field
     */
    double value;

    /**
     *  constructeurs
     */
    public Voxel3D() {
        super();
        value = Float.NaN;
    }

    /**
     *  constructeurs
     *
     *@param  x      Description of the Parameter
     *@param  y      Description of the Parameter
     *@param  z      Description of the Parameter
     *@param val
     */
    public Voxel3D(int x, int y, int z, float val) {
        super(x, y, z);
        value = val;
    }

    /**
     *  Constructor for the Voxel3D object
     *
     *@param  x      Description of the Parameter
     *@param  y      Description of the Parameter
     *@param  z      Description of the Parameter
     *@param val
     */
    public Voxel3D(int x, int y, int z, double val) {
        super(x, y, z);
        value = val;
    }

    /**
     *
     * @param x
     * @param y
     * @param z
     * @param val
     */
    public Voxel3D(double x, double y, double z, double val) {

        super(x, y, z);
        value = val;
    }

    /**
     *  Sets the pixel attribute of the Voxel3D object
     *
     *@param  x      The new pixel value
     *@param  y      The new pixel value
     *@param  z      The new pixel value
     *@param  value  The new pixel value
     */
    public void setVoxel(int x, int y, int z, float value) {
        setX(x);
        setY(y);
        setZ(z);
        this.value = value;
    }

    /**
     *  Sets the pixel attribute of the Voxel3D object
     *
     *@param  x      The new pixel value
     *@param  y      The new pixel value
     *@param  z      The new pixel value
     *@param  value  The new pixel value
     */
    public void setVoxel(int x, int y, int z, double value) {
        setX(x);
        setY(y);
        setZ(z);
        this.value = (float) value;
    }

    /**
     *  Gets the value attribute of the Voxel3D object
     *
     *@return    The value value
     */
    public double getValue() {
        return value;
    }

    @Override
    public String toString() {
        return ("(" + getX() + " , " + getY() + " , " + getZ() + ")");
    }

    
}
